SystemOrganization addCategory: #'SUnit-UITesting'!

!Workspace methodsFor: '*SUnit-UITesting' stamp: 'StephaneDucasse 11/2/2012 11:08'!
hasUnacceptedEdits
	"Answer true if any of the views on this model has unaccepted edits."

	self dependents
		do: [:each | 
			self flag: #fixMe. "The check for #respondsTo: is a hack necessary just because the old
			Browser uses it wrong. We need to change this after old Browser removal"
			((each respondsTo: #hasUnacceptedEdits) and: [ each hasUnacceptedEdits ]) 
				ifTrue: [^ true]]
		without: self.
	^ false
! !

Morph subclass: #MenuCaptureMorph
	instanceVariableNames: 'worldBefore timeout timer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!MenuCaptureMorph class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 12/9/2011 21:19'!
timingOutAfter: aDuration

	^ (self new setTimeout: aDuration) openInWorld.! !

!MenuCaptureMorph methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 12/9/2011 21:20'!
initialize

	worldBefore := World submorphs.
	timer := Stopwatch new activate.! !

!MenuCaptureMorph methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 12/9/2011 21:19'!
setTimeout: aDuration

	timeout := aDuration.
	^ self.! !

!MenuCaptureMorph methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 12/9/2011 21:12'!
step

	Transcript show: 'moving'.! !

Morph subclass: #MenuCapturingMorph
	instanceVariableNames: 'menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!MenuCapturingMorph methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 12/14/2011 14:06'!
menu

	^ menu.! !

!MenuCapturingMorph methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 12/14/2011 14:08'!
step

	menu := World submorphs detect: [ :m | m isKindOf: MenuMorph ] ifNone: [ menu ].
	menu isNil ifFalse: [ 
		menu delete.
		self delete ].! !

Morph subclass: #MorphHandlingMiddleButton
	instanceVariableNames: 'menu receivedBlueButtonUp receivedBlueButtonDown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!MorphHandlingMiddleButton methodsFor: 'meta-actions' stamp: 'SeanDeNigris 12/14/2011 15:18'!
blueButtonDown: anEvent

	receivedBlueButtonDown := true.! !

!MorphHandlingMiddleButton methodsFor: 'meta-actions' stamp: 'SeanDeNigris 12/14/2011 15:18'!
blueButtonUp: anEvent

	receivedBlueButtonUp := true.! !

!MorphHandlingMiddleButton methodsFor: 'meta-actions' stamp: 'SeanDeNigris 12/14/2011 15:17'!
handlerForBlueButtonDown: anEvent

	^ self.! !

!MorphHandlingMiddleButton methodsFor: 'initialization' stamp: 'SeanDeNigris 12/14/2011 15:24'!
initialize

	super initialize.
	receivedBlueButtonUp := receivedBlueButtonDown := false.! !

!MorphHandlingMiddleButton methodsFor: 'testing' stamp: 'SeanDeNigris 12/14/2011 15:21'!
wasClickedWithMiddleButton

	^ receivedBlueButtonDown and: [ receivedBlueButtonUp ].! !

TestCase subclass: #SimulateKeystrokesSpecification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!SimulateKeystrokesSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:04'!
testSimulateCmdKeystroke

	| ws |
	ws := Workspace open.
	self simulateKeyStrokes: 'var := 3.'.
	self simulateKeyStroke: $s command.
	self assert: ws hasUnacceptedEdits = false.
	ws dependents first delete.! !

!SimulateKeystrokesSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:04'!
testSimulateKeystroke

	| textMorph |
	textMorph := TextMorph new contents: ''; openInWorld.
	textMorph takeKeyboardFocus.
	self simulateKeyStroke: $s.
	self assert: textMorph contents = 's'.
	textMorph delete.! !

!SimulateKeystrokesSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:04'!
testSimulateKeystrokes

	| textMorph |
	textMorph := TextMorph new contents: ''; openInWorld.
	textMorph takeKeyboardFocus.
	self simulateKeyStrokes: 'hello'.
	self assert: textMorph contents = 'hello'.
	textMorph delete.! !

TestCase subclass: #SimulateMouseSpecification
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!SimulateMouseSpecification methodsFor: 'helpers' stamp: 'SeanDeNigris 12/14/2011 14:07'!
menuOpenedDuring: aBlock

	| jailor |
	jailor := MenuCapturingMorph new openInWorld.
	aBlock value.
	^ jailor menu.! !

!SimulateMouseSpecification methodsFor: 'running' stamp: 'SeanDeNigris 12/14/2011 14:05'!
tearDown

	morph delete.! !

!SimulateMouseSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:01'!
testSimulateClick
	"self run: #testSimulateClick"

	morph := TextMorph new contents: ''; openInWorld.	
	morph simulateClick.
	self assert: morph hasKeyboardFocus.! !

!SimulateMouseSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:02'!
testSimulateMiddleClick
	"self run: #testSimulateMiddleClick"
	morph := MorphHandlingMiddleButton new openInWorld.
	morph simulateMiddleClick.
	self assert: morph wasClickedWithMiddleButton.
! !

!SimulateMouseSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:02'!
testSimulateRightClick
	"self run: #testSimulateRightClick"
	
	| workspace menu sem before after |
	workspace := Workspace open.
	morph := self waitForMorphThat: [ :its | its model == workspace ].
	menu := self menuOpenedDuring: [ morph simulateRightClick ].
	self assert: menu isNil not.! !

!SimulateMouseSpecification methodsFor: 'helpers' stamp: 'SeanDeNigris 12/9/2011 17:37'!
timeoutAfter: aDuration ifNot: aBlock

	| timer |
	timer := Stopwatch new activate.
	[ timer duration < aDuration and: [ aBlock value not ] ] whileTrue.! !

!SimulateMouseSpecification methodsFor: 'helpers' stamp: 'SeanDeNigris 12/14/2011 13:57'!
waitForMorphThat: aBlock

	[
		morph := World submorphThat: aBlock ifNone: [ nil ].
		(Delay forMilliseconds: 100) wait.
		morph isNil ] whileTrue.
	^ morph.! !
